function Ped02300_preco_base_Controller(templateManager, ScreenService, General, Ped02300PrecoBaseServices, restEngine, MessageService) {
    var checkedFields = [];
    var checkedFieldsReajuste = [];
    
    this.savePrecoBase = function(args){
        
        General.saveCrud(args.owner.widget).then(function(success){
            General.changeWidgetAcessibility(args.owner.widget.widgets,true);
        });
        
    };
    
    this.saveListaItemPreBase = function(widget){
        if(widget.currentRow.VRITEPREBASE == '0.00' || widget.currentRow.VRITEPREBASE == '0'){
            ScreenService.showMessage("O preço do produto deve ser diferente de 0.00"); 
        }else{
            Ped02300PrecoBaseServices.retornaOperadorLogado().then(function(operadorLogado){
                widget.currentRow.CDOPERATZIPB =  operadorLogado[0].CDOPERADOR;
                General.saveCrud(widget);
            });   
        }
        
        
    };
    
    this.setDataSourceFilterPromocao = function(widget){
        widget.dataSourceFilter = [
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widget.getParent().getParent().getParent().currentRow.CDPRECOBASE
            },
            {
                name: "P_DTINIVALIPB",
                operator: "=",
                value: widget.getParent().currentRow.DTINIVALIPB
            },
            {
                name: "P_CDPRODUTO",
                operator: "=",
                value: widget.getParent().currentRow.CDPRODUTO
            }
        ];
        widget.reload();
    };
    
    this.getNrorg = function(){
        return templateManager.container.getWidget('promocao').currentRow.NRORG;
    };
    
    this.salvarPromoPrBase = function(widget){
        if(widget.isValid()){
            this.setPreco(widget);
            var dadosPromoPrBase;
            var row = widget.currentRow;
                if(widget.currentRow.__is_new){
                    Ped02300PrecoBaseServices.newCode(row).then(function(success){
                        dadosPromoPrBase = {
                            "__createdLocal": true,
                            "__index": 4,
                            "__isSelected": false,
                            "__is_new": true,
                            "__notSelectable": false,
                            "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                            "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                            "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                            "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                            "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                            "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                            "DTINIPROMO": widget.currentRow.DTINIPROMO,
                            "DTFINPROMO": widget.currentRow.DTFINPROMO,
                            "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                            "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                            "NRORG": this.getNrorg(),
                            "CDPROMOCAO": success.dataset.data[0]
                        };
                        Ped02300PrecoBaseServices.setPromoPrBase(dadosPromoPrBase).then(function(){
                            ScreenService.closeSwipe();
                            widget.getField('VRPERBASEPROMO').readOnly = true;
                            widget.getField('VRTOTALPROMO').readOnly = false;
                            widget.reload();
                        }.bind(this), function (error) {
                            ScreenService.showMessage(error.error);
                        });  
                    }.bind(this), function(error){
                        ScreenService.showMessage(error);    
                    });
                } else {
                    dadosPromoPrBase = {
                        "__index": 2,
                        "__isSelected": false,
                        "__is_new": false,
                        "__notSelectable": false,
                        "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                        "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                        "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                        "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                        "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                        "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                        "DTINIPROMO": widget.currentRow.DTINIPROMO,
                        "DTFINPROMO": widget.currentRow.DTFINPROMO,
                        "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                        "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                        "NRORG": this.getNrorg(),
                        "CDPROMOCAO": widget.currentRow.CDPROMOCAO
                    };
                    Ped02300PrecoBaseServices.setPromoPrBase(dadosPromoPrBase).then(function(){
                        ScreenService.closeSwipe();
                        widget.getField('VRPERBASEPROMO').readOnly = true;
                        widget.getField('VRTOTALPROMO').readOnly = false;
                        widget.reload();
                    }.bind(this), function (error) {
                        ScreenService.showMessage(error.error);
                    });    
                }
        }
    };
    
    this.editar = function(widget){
        if(widget.currentRow.VRITEPREBASE == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDOPERATZIPB = getLocalVar("ERP_CDOPERADOR");
            widget.currentRow.DTHRATZIPB = moment().format('DD/MM/YYYY');
            widget.currentRow.CDPRECOBASE = General.getFieldValue('CDPRECOBASE', 'precoBase');
        }
        General.edit(widget);
    };
    
    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        widget.reload();
        this.prodFin(widget);
    };
    
    this.prodFin = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('listaItemPreBase');
        widget.dataSourceFilter = [
            {
                name: "P_NRORG",
                operator: "=",
                value: widget.getParent().getParent().currentRow.NRORG
            },
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widget.getParent().getParent().currentRow.CDPRECOBASE
            }
        ];
        if(row.NMPRODFIN){
            if(row.P_PRODINI > row.P_PRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    
    this.setFieldValor = function(args){
        var row = args.owner.field.widget.currentRow;
        if(row.IDTIPOPROMO != "V"){
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = false;
        } else {
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = true;
        }
    };
    
    this.setPreco = function(widget){
        var porcentagem;
        var row = widget.currentRow;
        row.VRITEPREBASE = General.getFieldValue('VRITEPREBASE','listaItemPreBase');
        if(row.IDTIPOPROMO == "A"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE + porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        } 
        if(row.IDTIPOPROMO == "D"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE - porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        }
    };
    
    this.setView = function(widget){
        if(widget.container.getWidget('listaItemPreBase').getField('VRITEPREBASE').value() == undefined){
            General.changeWidgetAcessibility(widget.widgets,false);
        } else {
            General.changeWidgetAcessibility(widget.widgets,true);
        }
        switch (widget.getParent().getParent().currentRow.IDULTPRECPROMO) {
            case 'S':
                widget.widgets[0].isVisible = true;
                widget.widgets[1].isVisible = false;
                widget.widgets[2].isVisible = true;
                break;
            case 'N':
                widget.widgets[0].isVisible = false;
                widget.widgets[1].isVisible = true;
                widget.widgets[2].isVisible = true;
                break;
        }
        widget.reload();
    };
    
    this.prodIniFator = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFINFATOR').readOnly = !row.NMPRODINIFATOR;
        widget.getField('NMPRODFINFATOR').readOnlyOnEdit = !row.NMPRODINIFATOR;
        this.prodFinFator(widget);
    };
    
    this.prodFinFator = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('produtosFatorAjuste');
        widget.dataSourceFilter = [
            {
                name: "P_CDFATPRECO",
                operator: "=",
                value: General.getFieldValue('CDFATPRECO', 'fator')
            }
        ];
        if(row.NMPRODFINFATOR){
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    
    this.editarFator = function(widget){
        if(widget.currentRow.VRFATPRECO == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDFATPRECO = General.getFieldValue('CDFATPRECO', 'fator');
        }
        General.edit(widget);
    };
    
    this.validaIntervalo = function(widget) {
        restEngine.post("/validaIntervalo",{'requestType': 'DataSet', 'dataset': [widget.currentRow]})
        .then(function (data) {
            widget.reload();
        }).
        catch(function(e){
            ScreenService.showMessage(e.data.error);
            widget.currentRow.QTCONVINIPRB = "";
            widget.currentRow.QTCONVFINPRB = "";
        });
    };
    
    this.validaValor = function(widget){
        if(widget.currentRow.VRPREBASECONV <= 0 || widget.currentRow.VRPREBASECONV == null){
            ScreenService.showMessage("O valor não pode ser menor ou igual a zero.");
        } else { 
            General.saveCrud(widget);
            widget.reload();
        }    
    };
    
    this.preparaExportacao = function(widget){
        checkedFields[0] = widget.getCheckedRows();
        
        var ItemNull = false;
        var ItemCount = 0;
        var ItemNameArray = [];
        var ItemNameString = "";
        
        if(!checkedFields[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFields[0].length; i++){
                if(checkedFields[0][i].CDPRECOBASE == null){
                    ItemNull = true;
                    ItemCount++;
                    ItemNameArray.push(checkedFields[0][i].NMPRODUTO);
                }
            }
            
            if (ItemNull) {
                
                ItemNameString = "'" + ItemNameArray[0] + "'";
                
                for (i = 1; i < ItemNameArray.length; i++) {
                    
                    if(i == ItemNameArray.length-1) {
                        ItemNameString += " e '" + ItemNameArray[i] + "'";
                    } else {
                        ItemNameString += ", '" + ItemNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemNameString + " não possui(em) preço(s).");
                var var_produtoNaoPossuiPreco_msg = "PRODUTO_NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_produtoNaoPossuiPreco_msg,{"PRODUTO": ItemNameString});
                
                return 0;
                
            } else {
                var newWidget = templateManager.container.getWidget("exportItem_popup");
                newWidget.dataSourceFilter = [
                    {
                        "name": "CDPRECOBASE",
                        "operator": "<>",
                        "value": widget.getParent().getParent().currentRow.CDPRECOBASE
                    }
                ];
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                newWidget.reload();
                ScreenService.openPopup(newWidget);
            }
            
            
        }
    };
    
    this.closeExport = function(widget) {
      ScreenService.closePopup();
      widget.isVisible = false;
    };
    
    this.exportPrecos = function(widget){
        checkedFields[1] = widget.getCheckedRows();
        
        restEngine.post("ped_pedidos#/exportarItem",{
            'requestType': 'DataSet', 
            'dataset': [checkedFields]
            
        }).then(function(success) {
            ScreenService.showMessage("Itens importados com sucesso.");
            ScreenService.closePopup();  
        }, function(callback){
            ScreenService.showMessage("Não foi possível exporta os itens selecionados.");
            ScreenService.closePopup();  
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.reajuste = function(widget){
        checkedFieldsReajuste[0] = widget.getCheckedRows();
        
        var ItemReajusteNull = false;
        var ItemReajusteCount = 0;
        var ItemReajusteNameArray = [];
        var ItemReajusteNameString = "";
        
        if(!checkedFieldsReajuste[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFieldsReajuste[0].length; i++){
                if(checkedFieldsReajuste[0][i].CDPRECOBASE == null){
                    ItemReajusteNull = true;
                    ItemReajusteCount++;
                    ItemReajusteNameArray.push(checkedFieldsReajuste[0][i].NMPRODUTO);
                }
            }
            
            if (ItemReajusteNull) {
                
                ItemReajusteNameString = "'" + ItemReajusteNameArray[0] + "'";
                
                for (i = 1; i < ItemReajusteNameArray.length; i++) {
                    
                    if(i == ItemReajusteNameArray.length-1) {
                        ItemReajusteNameString += " e '" + ItemReajusteNameArray[i] + "'";
                    } else {
                        ItemReajusteNameString += ", '" + ItemReajusteNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemReajusteNameString + " não possui(em) preço(s).");
                var var_naoPossuiPreco_msg = "NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_naoPossuiPreco_msg,{"ITEM": ItemReajusteNameString});
                return 0;
                
            } else {
                ScreenService.showMessage("As promoções desse item vão ser apagados após o reajuste");
                var newWidget = templateManager.container.getWidget("reajuste_popup");
                newWidget.isVisible = true;
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                ScreenService.openPopup(newWidget);
            }
            
        }
    };
    
    this.reajustePrecos = function(widget){
        
        if(widget.currentRow.IDTIPOREAJUSTE == null){
            ScreenService.showMessage("Selecione um tipo de reajuste.");
            return 0;
        }
        if(widget.currentRow.VRPERBASEPROMO <= 0){
            ScreenService.showMessage("O valor da porcentagem não pode ser menor ou igual a 0;");
            return 0;
        }
        
        checkedFieldsReajuste[1] = widget.currentRow.VRPERBASEPROMO;
        checkedFieldsReajuste[2] = widget.currentRow.DTFIMVALIPB;
        checkedFieldsReajuste[3] = widget.currentRow.IDTIPOREAJUSTE;
        
        
        
        restEngine.post("/reajusteItem",{'requestType': 'DataSet', 'dataset': [checkedFieldsReajuste]}).then(function() {
            ScreenService.showMessage("Itens reajustado com sucesso.");
            ScreenService.closePopup();
            widget.getParent().reload();
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.saveFatorPreco = function(widget){
        if(widget.currentRow.__is_new == true){    
            Ped02300PrecoBaseServices.saveFatorPreco(widget.currentRow).then(function(sucess){
                ScreenService.goBack();
                widget.reload();
            }, function(error){
                ScreenService.showMessage(error.data.error);
            });
        } else {
            General.saveCrud(widget);
        }
    };
    
    this.newRowDesc = function(widget){
        widget.newRow();
        widget.currentRow.CDPRECOBASE = widget.getParent().getParent().currentRow.CDPRECOBASE;
        widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
    };
    
    this.fieldOnChangePais = function(){
        var widget = templateManager.container.getWidget('desconto_maximo');
        var dadosWidget = templateManager.container.getWidget('desconto_maximo_grid');
        
        if(!widget.getField('NMPAIS').value()) {
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            dadosWidget.isVisible = true;
            dadosWidget.activate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = true;
            });
            dadosWidget.reload();
        }
    };
    
    this.verificaPorcentagem = function(field){
        var valor_porcentagem = parseFloat(field.value().toString().replace(",","."));
        if((valor_porcentagem < 0) || (valor_porcentagem > 100)){
            //ScreenService.showMessage(field.label+" deve ser entre 0 e 100.");
            var var_porcentagem_msg = "PORCENTAGEM_MSG";
            MessageService.showMessageByCode(var_porcentagem_msg,{"FIELD": field.label});
            
            field.clearValue();
        }
    };
    
    this.getLevelByMaskNomeProduto = function(widget){
        var filtro = General.getLevelByMask('CDPICTPROD',1).length;
        
        widget.getField('NMPRODUTO').dataSourceFilter[0] = {
            "name": "CDNVPRODUTO",
            "operator": "=",
            "value": filtro
        };
        
        widget.getField('NMPRODUTO').reload();
    };
    
    this.validaDataFinalValidade = function(){
        var widget = templateManager.container.getWidget('listaItemPreBase');
        var dataInicial = widget.getField('DTINIVALIPB').value();
        var dataFinal = widget.getField('DTFIMVALIPB').value();
        
        if(dataFinal < dataInicial){
            ScreenService.showMessage("A data final deve ser maior do que a data Inicial");
            widget.getField('DTFIMVALIPB').setValue(null);
        }
    };
    
    this.verificaValidade = function(){
        var widget = templateManager.container.getActiveWidget();
        var maiorDataFinal;
        var filter = [
            {
                "name": "CDPRODUTO",
                "operator": "=",
                "value": widget.currentRow.CDPRODUTO
            }
        ];
        
        
        General.callRestEngine('ped#/crud/itemprebase', 'FilterData', filter).then(function(callback){
            var validades = callback.dataset.itemprebase;
            validades.forEach(comparaValidade);
            
            function comparaValidade(validade, index){
                if(index == 0){
                    maiorDataFinal = validade.DTFIMVALIPB;
                }else{
                    if(validade.DTFIMVALIPB > maiorDataFinal){
                        maiorDataFinal = validade.DTFIMVALIPB;
                    }
                }
            }
            this.validaDataInicialValidade(maiorDataFinal);
        }.bind(this));
    };
    
    this.validaDataInicialValidade = function(maiorDataFinal){
        var widget = templateManager.container.getWidget('listaItemPreBase');
        var dataInicial = widget.getField('DTINIVALIPB').value();
        var dataFinal = widget.getField('DTFIMVALIPB').value();
        dataInicial = dataInicial.substr(0, 10);
        maiorDataFinal = maiorDataFinal.substr(0, 10);
        dataInicial = moment(dataInicial, 'DD/MM/YYYY').format();
        maiorDataFinal = moment(maiorDataFinal, 'DD/MM/YYYY').format();
        if(dataInicial < maiorDataFinal){
            ScreenService.showMessage("A data inicial deve ser maior do as datas finais das outras validades.");
            widget.getField('DTINIVALIPB').setValue(null);
        }else{
            if(dataFinal){
                if(dataFinal < dataInicial){
                    ScreenService.showMessage("A data inicial deve ser maior do que a data Final.");
                    widget.getField('DTFIMVALIPB').setValue(null);
                }
            }    
        }   

    };
    
    this.novaValidade = function(widget){
        var codigo = widget.currentRow.CDARVPROD;
        var nome = widget.currentRow.NMPRODUTO;
        var unidade = widget.currentRow.SGUNIDADE;
        var CDOPERATZIPB =  widget.currentRow.CDOPERATZIPB;
        var CDPRECOBASE =  widget.currentRow.CDPRECOBASE;
        var NRORG =  widget.currentRow.NRORG;
        var CDPRODUTO = widget.currentRow.CDPRODUTO;

        widget.newRow();
        widget.currentRow.CDARVPROD = codigo;
        widget.currentRow.NMPRODUTO = nome;
        widget.currentRow.SGUNIDADE = unidade;
        widget.currentRow.CDOPERATZIPB = CDOPERATZIPB;
        widget.currentRow.CDPRECOBASE = CDPRECOBASE;
        widget.currentRow.NRORG = NRORG;
        widget.currentRow.CDPRODUTO = CDPRODUTO;
        widget.currentRow.DTHRATZIPB = moment().format('DD/MM/YYYY');
        widget.reload();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped02300_preco_base_Controller', Ped02300_preco_base_Controller);
});