function Ped00100_lancamentoPedido_Repository (restEngine, localStorageEngine) {

    // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  DESKTOP
    
    this.montaConfigTransmissao = function(row) {
        var filter = [
            {
                "name": "ROW",
                "operator": "=",
                "value": row
            }
        ];
        return localStorageEngine.download("df#/config_transmissao", filter);
    };
    
    this.getNewCode = function(filial) {
        return restEngine.post('ped#/novoCodigo', {
            "requestType": "Row",
            "row": filial
        });
    };

    this.updateOrder = function(row) {
        return restEngine.post('ped#/pedido_completa/updateOrder', {
            "requestType": "DataSet",
            "dataset": row
        });
    };

    this.findModpgtoPrazo = function(filter) {
        return restEngine.post('ped#/crud/modpgto_prazomodpgto', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.retornaParamPedido = function() {
        return restEngine.post('ped#/crud/parampedido', {
            "requestType": "FilterData"
        });
    };

    this.retornaPrecobase = function() {
        return restEngine.post('ped#/crud/precobase', {
            "requestType": "FilterData"
        });
    };

    this.retornaPrecobasecli = function() {
        return restEngine.post('ped#/precobasecli_precobase', {
            "requestType": "FilterData"
        });
    };

    this.retornaPendenciaFin = function() {
        return restEngine.post('ped#/crud/contareceber_boletreceber_notafiscal', {
            "requestType": "FilterData"
        });
    };
    
    this.checkLogin = function(filter) {
        return restEngine.post('ped#/aprovacao/checkLogin', {
            "requestType": "DataSet",
            "dataset": filter
        });
    };

    this.savePedido = function(data) {
        return restEngine.post('ped#/pedido_completa/save', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.deletePrazo = function(data) {
        return restEngine.post('ped#/pedido_completa/delete', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    
    this.salvarEncargo = function(data) {
        return restEngine.post("ped_pedidos#/encargo_lancamento/save", {
            "requestType": "DataSet",
            "dataset": data
        });
    };

    // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  MOBILE
    this.enviarPedido = function(data) {
        return restEngine.post('ped#/enviarPedido', {
            "requestType": "DataSet",
            "dataset": data
        });
    };
    this.findClienteVendedor = function(filter) {
        return restEngine.post('ped#/crud/cliente_completa', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.findProduto = function(filter) {
        return restEngine.post('ped#/crud/produto_itemprebase_promoprbase', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.filtraVendedor = function(filter) {
        return restEngine.post('ped#/crud/vendedor', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.findQTprod = function() {
        return restEngine.post('ped#/crud/reservaped_sum_qttotalestoq', {
            "requestType": "FilterData"
        });
    };
    this.findModpgtoPrazoMod = function() {
        return restEngine.post('ped#/crud/modpgto_prazomodpgto', {
            "requestType": "FilterData"
        });
    };
    this.findModpgto = function() {
        return restEngine.post('ped#/crud/modpgto', {
            "requestType": "FilterData"
        });
    };
    this.findParameters = function(filter) {
        return restEngine.post('ped#/crud/parampedido', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
    this.findParamPedido = function(filter) {
        return restEngine.post('ped#/crud/ped_parampedido', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
    this.findTpdesc = function() {
        return restEngine.post('ped#/crud/tipodesc', {
            "requestType": "FilterData"
        });
    };
    this.findTpOperac = function(filter) {
        return restEngine.post('ped#/crud/tipooperac', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.retornaDadosUnidade = function(filter) {
        return restEngine.post('ped#/crud/filial_empresa_endefili', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    this.filtraFilioper = function(filter) {
        return restEngine.post('ped#/crud/filioper', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.enviarEmail = function(emails) {
        return restEngine.post('ped#/email', {
            "requestType": "DataSet",
            "dataset": emails
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ped00100_lancamentoPedido_Repository', Ped00100_lancamentoPedido_Repository);
});